###########################
# Options and flows
###########################
set ProjectDir .
set lib_path /home/360.1.430-IRT_SMART_IMAGER/WP3/Task3.1-3DCAD/5-N2D2-to-HLS/catapult_libs
# set techlib_path /xxxxxxxxxxxx/techlibs
file mkdir $lib_path/Cache
options set Cache/UserCacheHome $lib_path/Cache
options set Clustering/prototype_rom false
options set ComponentLibs/SearchPath [list $lib_path $lib_path/RAM_SP_generic $lib_path/RegFile] -append
# options set ComponentLibs/TechLibSearchPath [list $techlib_path/LIB $techlib_path/TECH $techlib_path/LEF $techlib_path/PTF]
options set Input/CppStandard c++11
options set Input/TargetPlatform x86_64
options set Input/SearchPath [list $ProjectDir/include $ProjectDir/dnn/include]
options set Output/OutputVHDL false
options set Output/OutputVerilog true
options set Output/RTLSchem false
# options set Flows/QuestaSIM/Path $env(QUESTA_HOME)/bin 
# options set Flows/OasysRTL/Path $env(OASYS_HOME)/bin
options set Flows/OasysRTL/CustomScriptDirPath $lib_path
options set Flows/OasysRTL/AreaOptParallelism 8
flow package require /SCVerify
flow package option set /SCVerify/DISABLE_EMPTY_INPUTS true

###########################
# Input model
###########################
solution file add include/Network.hpp
solution file add main.cpp -exclude true
go analyze

###########################
## Hierarchy
###########################
solution design set N2D2::Network -top
go compile
project save
set Net [solution get /name]

###########################
## Libraries
###########################
solution library add nangate-45nm_beh -- -rtlsyntool OasysRTL -vendor Nangate -technology 045nm
# solution library add C28SOI_SC_12 -- -rtlsyntool OasysRTL -vendor ST -technology C28SOI
solution library add RAM_SP
solution library add RegFile
solution library add ccs_sample_rom
go libraries

###########################
## Clock and reset
###########################
directive set -CLOCKS {clk {-CLOCK_PERIOD 3.33 -CLOCK_EDGE rising -CLOCK_HIGH_TIME 1.665 -CLOCK_OFFSET 0.0 -CLOCK_UNCERTAINTY 0.0 -RESET_KIND async -RESET_SYNC_NAME rst -RESET_SYNC_ACTIVE high -RESET_ASYNC_NAME arst_n -RESET_ASYNC_ACTIVE low -ENABLE_NAME {} -ENABLE_ACTIVE high}}
go assembly

###########################
## Architecture constraints
###########################
directive set /$Net/start:rsc -MAP_TO_MODULE ccs_ioport.ccs_sync_in_vld
directive set /$Net/inputs:rsc -MAP_TO_MODULE RAM_SP.RAM_SP

###########################
## Variable part
###########################

{% for func in functions %}
{{ func }}
{% endfor %}


set hier N2D2::mem_out<7,7,1024,UDATA_T>
directive set /$Net/$hier/run/OUTPUTS -PIPELINE_INIT_INTERVAL 1

directive set /$Net/outputs:rsc -MAP_TO_MODULE RAM_SP.RAM_SP
go architect

###########################
## Schedule
###########################
go allocate

###########################
## Generate RTL
###########################
go extract

# SCVerify RTL simulation - batch
flow run /SCVerify/launch_make ./scverify/Verify_concat_sim_rtl_v_msim.mk VOPT_ARGS= sim

# SCVerify RTL simulation - batch with activity report by layer
#source ../script/sim_with_activity_report.tcl
#sim_with_activity_report questasim.do
#flow run /SCVerify/launch_make ./scverify/Verify_concat_sim_rtl_v_msim.mk MSIM_DOFILE=questasim.do sim

# SCVerify RTL simulation - GUI
#flow run /SCVerify/launch_make ./scverify/Verify_concat_sim_rtl_v_msim.mk VOPT_ARGS=+acc=p simgui

# RTL synthesis with Oasys
# flow run /OasysRTL/launch_tool ./concat_rtl.v.or v
